    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.scheme;
    022
    023import cascading.tap.Tap;
    024import cascading.tuple.TupleEntry;
    025
    026/**
    027 * SinkCall provides access to the current {@link Scheme#sink(cascading.flow.FlowProcess, SinkCall)} invocation
    028 * arguments.
    029 * <p/>
    030 * Use the Context to store thread local values.
    031 *
    032 * @param <Context>
    033 * @param <Output>
    034 */
    035public interface SinkCall<Context, Output>
    036  {
    037  /**
    038   * Method getContext returns the context of this SinkCall object.
    039   *
    040   * @return the context (type C) of this SinkCall object.
    041   */
    042  Context getContext();
    043
    044  /**
    045   * Method setContext sets the context of this SinkCall object.
    046   *
    047   * @param context the context of this SinkCall object.
    048   */
    049  void setContext( Context context );
    050
    051  /**
    052   * Method getOutgoingEntry returns the final {@link TupleEntry} to be passed to the
    053   * {@link #getOutput()} output handler.
    054   * <p/>
    055   * That is, the result of calling getOutgoingEntry() should be passed directly to the
    056   * platform specific output handler returned by getOutput().
    057   * <p/>
    058   * Note the returned value from this method cannot be modified.
    059   *
    060   * @return TupleEntry
    061   */
    062  TupleEntry getOutgoingEntry();
    063
    064  Output getOutput();
    065
    066  /**
    067   * Method getTap returns the parent {@link Tap} instance that encapsulates the current {@link Scheme} instance.
    068   *
    069   * @return the parent Tap
    070   */
    071  Tap getTap();
    072  }